#include "CodaBase.h"

#ifndef __CODA_CIRC__
#define __CODA_CIRC__

template <class Elem> 
class CodaCirc : public CodaBase<Elem> {
 private:
        Elem  *dati;
        int   MaxSize;
        int   CurSize;
        int   headPos;
        int   tailPos;
 public:

        CodaCirc(int ms);
        virtual ~CodaCirc();
        virtual bool enqueue(Elem e);
        virtual bool dequeue();
        virtual bool head(Elem &e);
        bool isempty();
};

template <class Elem> 
CodaCirc<Elem>::CodaCirc(int ms)
{
   MaxSize = ms;
   CurSize = 0;
   headPos = 0;
   tailPos = 0;
   dati = new Elem[MaxSize];      
}

template <class Elem> 
CodaCirc<Elem>::~CodaCirc()
{
   delete[] dati;       
}

template <class Elem> 
bool CodaCirc<Elem>::enqueue(Elem e)
{
     if (CurSize==MaxSize)
     {
        return false;                     
     }    
     
     dati[tailPos] = e;
     CurSize++;
     tailPos = (tailPos +1)%MaxSize;
     return true;
};

template <class Elem> 
bool CodaCirc<Elem>::dequeue() {
     
     if (CurSize==0) 
        return false;
     CurSize--;
     headPos = (headPos+1)%MaxSize;
     return true;
};

template <class Elem> 
bool CodaCirc<Elem>::head(Elem &e)
{
     if (CurSize>0)
     {
        e = dati[headPos]; 
        return true;
     } 
     else 
          return false;
};

template <class Elem> 
bool CodaCirc<Elem>::isempty() 
{
     if (CurSize==0) 
        return true; 
     else
        return false;
};      
#endif
